//  AEdit 0.5.1 -:-  (C)opyright 2000-2001 Kristian Van Der Vliet
//
// This is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


#include "edittext.h"
#include "finddialog.h"
#include "gotodialog.h"
#include <storage/FilePanel.h>


const unsigned int MENU_OFFSET=15;

using namespace os;

class AEditWindow : public CWindow
{
	public:
		AEditWindow(const CRect& cFrame);
		void DispatchMessage(CMessage* pcMsg, CHandler* pcHandler);
		virtual void MessageReceived(CMessage* pcMessage);
		virtual bool OkToQuit( void );
		void LoadAtStart(char* cFilename);

	private:
		void ShowAbout();
		void Load(char* cFileName);
		void Save(const char *cFileName);

		CRect sWindowBounds;
		CRect sMenuFrame;
		EditTextView* pcTextView;
		CView* pcButtonBar;
		CFilePanel* pcLoadRequester;
		CFilePanel* pcSaveRequester;
		const char* pzFPath;				// File name
		char pzStorePath[256];				// File name store
		char pcWindowTitle[256];			// Text in title bar

		std::string m_cFamily;				// Font family currently selected
		std::string m_cStyle;				// Font style currently selected
		float m_vSize;						// Font size currently selectes

		FindDialog* pcFindDialog;			// Find dialog
		ReplaceDialog* pcReplaceDialog;		// Replace dialog

		std::string sFindText;				// All used for find & replace
		std::string sReplaceText;
		int iTextPosition,iCurrentLine, iTotalLines;
		TextView::buffer_type vLines;
		TextView::buffer_type vNewLines;
		bool bHasFind;
		bool bCaseSensitive;

		GotoDialog* pcGotoDialog;			// Goto Line dialog
		int32 iGotoLineNo;					// Line number requested
};
