//  AEdit 0.5.1 -:-  (C)opyright 2000-2001 Kristian Van Der Vliet
//
// This is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include "buttonbar.h"
#include "messages.h"

unsigned int BUTTON_HEIGHT=21;
unsigned int BUTTON_WIDTH=21;

uint8 ButtonNew[]= {
	#include "images/new.hex"
};

uint8 ButtonOpen[]= {
	#include "images/open.hex"
};

uint8 ButtonSave[]= {
	#include "images/save.hex"
};

uint8 ButtonCut[]= {
	#include "images/cut.hex"
};

uint8 ButtonCopy[]= {
	#include "images/copy.hex"
};

uint8 ButtonPaste[]= {
	#include "images/paste.hex"
};

uint8 ButtonFind[]= {
	#include "images/find.hex"
};


ButtonBar::ButtonBar(const CRect &cFrame, const char* cName) : CView(cFrame, cName, CF_FOLLOW_TOP | CF_FOLLOW_LEFT | CF_FOLLOW_LEFT, WID_WILL_DRAW | WID_CLEAR_BACKGROUND)
{
	// Create & attach all the image buttons
	// Please do not ask me what the math is on this,
	// I probably couldn't tell you.  There's probably a better way
	// to do it with CRect.Point()'s, but it works at least :)

	sNewButton=new ImageButton(CRect(1,1,BUTTON_WIDTH,BUTTON_HEIGHT),"new","New",new CMessage(ID_FILE_NEW));
	sLoadButton=new ImageButton(CRect((BUTTON_WIDTH+1),1,(BUTTON_WIDTH*2),BUTTON_HEIGHT),"load","Load",new CMessage(ID_FILE_LOAD));
	sSaveButton=new ImageButton(CRect(((BUTTON_WIDTH*2)+1),1,(BUTTON_WIDTH*3),BUTTON_HEIGHT),"save","Save",new CMessage(ID_FILE_SAVE));

	sNewButton->SetBitmap(ButtonNew, sizeof(ButtonNew));
	sLoadButton->SetBitmap(ButtonOpen, sizeof(ButtonOpen));
	sSaveButton->SetBitmap(ButtonSave, sizeof(ButtonSave));

	AddChild(sNewButton);
	AddChild(sLoadButton);
	AddChild(sSaveButton);

	sCutButton=new ImageButton(CRect(((BUTTON_WIDTH*3)+21),1,(BUTTON_WIDTH*4)+20,BUTTON_HEIGHT),"cut","Cut",new CMessage(ID_EDIT_CUT));
	sCopyButton=new ImageButton(CRect(((BUTTON_WIDTH*4)+21),1,(BUTTON_WIDTH*5)+20,BUTTON_HEIGHT),"copy","Copy",new CMessage(ID_EDIT_COPY));
	sPasteButton=new ImageButton(CRect(((BUTTON_WIDTH*5)+21),1,(BUTTON_WIDTH*6)+20,BUTTON_HEIGHT),"paste","Paste",new CMessage(ID_EDIT_PASTE));

	sCutButton->SetBitmap(ButtonCut, sizeof(ButtonCut));
	sCopyButton->SetBitmap(ButtonCopy, sizeof(ButtonCopy));
	sPasteButton->SetBitmap(ButtonPaste, sizeof(ButtonPaste));

	AddChild(sCutButton);
	AddChild(sCopyButton);
	AddChild(sPasteButton);

	sFindButton=new ImageButton(CRect(((BUTTON_WIDTH*6)+41),1,(BUTTON_WIDTH*7)+40, BUTTON_HEIGHT), "find", "Find", new CMessage(ID_FIND_FIND));
	sFindButton->SetBitmap(ButtonFind, sizeof(ButtonFind));
	AddChild(sFindButton);
}

