//  AEdit 0.5.1 -:-  (C)opyright 2000-2001 Kristian Van Der Vliet
//
// This is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


#include "finddialog.h"
#include "messages.h"

FindDialog::FindDialog(const CRect& cFrame, CWindow* pcParent) : CWindow(cFrame, "Find", WT_UNTYPED_WINDOW, WND_NO_ZOOM_BUT | WND_NO_DEPTH_BUT | WND_NOT_RESIZABLE)
{
	pcParentWindow=pcParent;		// We need to know the parent window so we can send messages back to it

	// Create the Layoutviews

	pcMainLayoutView=new FindLayoutView(Bounds());
	
	// Add the View to the Window

	AddChild(pcMainLayoutView);
}

void FindDialog::MessageReceived(CMessage* pcMessage)
{

	switch(pcMessage->what)
	{

		case ID_BUT_FIND:
		{
			pcMessage->AddString("find_text",pcMainLayoutView->GetFindText());
			pcMessage->AddBool("case_check_state",	pcMainLayoutView->GetCaseCheckState());
			pcParentWindow->PostMessage(pcMessage,pcParentWindow);	// Send the messages from the dialog back to the parent window
			break;
		}

		default:
		{
			pcParentWindow->PostMessage(pcMessage,pcParentWindow);	// Send the messages from the dialog back to the parent window
			break;
		}
	}
}

//	The Replace Dialog is basically the same, but adds a Replace input box, 
//  and extra buttons for the replace functionality


ReplaceDialog::ReplaceDialog(const CRect& cFrame, CWindow* pcParent) : CWindow(cFrame, "Replace", WT_UNTYPED_WINDOW, WND_NO_ZOOM_BUT | WND_NO_DEPTH_BUT | WND_NOT_RESIZABLE)
{
	pcParentWindow=pcParent;		// We need to know the parent window so we can send messages back to it

	// Create the Layoutviews

	pcMainLayoutView=new ReplaceLayoutView(Bounds());
	
	// Add the View to the Window

	AddChild(pcMainLayoutView);
}

void ReplaceDialog::MessageReceived(CMessage* pcMessage)
{
	switch(pcMessage->what)
	{

		case ID_BUT_FIND:
		{
			pcMessage->AddString("find_text",pcMainLayoutView->GetFindText());
			pcMessage->AddBool("case_check_state",	pcMainLayoutView->GetCaseCheckState());
			pcParentWindow->PostMessage(pcMessage,pcParentWindow);	// Send the messages from the dialog back to the parent window
			break;
		}

		case ID_BUT_REPLACE:
		{
			pcMessage->AddString("find_text",pcMainLayoutView->GetFindText());
			pcMessage->AddString("replace_text",pcMainLayoutView->GetReplaceText());

			pcParentWindow->PostMessage(pcMessage,pcParentWindow);	// Send the messages from the dialog back to the parent window
			break;
		}

		default:
		{
			pcParentWindow->PostMessage(pcMessage,pcParentWindow);	// Send the messages from the dialog back to the parent window
			break;
		}
	}

}

