#ifndef _FIND_LAYOUT_VIEW_
#define _FIND_LAYOUT_VIEW_

#include <string>
#include <layoutview.h>
#include <interface/CheckBox.h>
#include <interface/StringView.h>
#include <interface/Button.h>
#include <interface/TextView.h>


using namespace os;

class FindLayoutView : public LayoutView
{
	public:
		FindLayoutView( const CRect &cFrame);

		std::string GetFindText(void);
		bool GetCaseCheckState(void);

	private:
		HLayoutNode* pcHLayoutNode;
		VLayoutNode* pcButtonNode;
		VLayoutNode* pcInputNode;

		CButton* pcFindButton;
		CButton* pcNextButton;
		CButton* pcCloseButton;

		TextView* pcFindTextView;

		CCheckBox* pcCaseCheckBox;

		CStringView* pcFindLabel;
};


class ReplaceLayoutView : public LayoutView
{
	public:
		ReplaceLayoutView( const CRect &cFrame);
		std::string GetFindText(void);
		std::string GetReplaceText(void);
		bool GetCaseCheckState(void);

	private:
		HLayoutNode* pcHLayoutNode;
		VLayoutNode* pcButtonNode;
		VLayoutNode* pcInputNode;

		CButton* pcFindButton;
		CButton* pcNextButton;
		CButton* pcReplaceButton;
		CButton* pcCloseButton;

		TextView* pcFindTextView;
		TextView* pcReplaceTextView;

		CCheckBox* pcCaseCheckBox;

		CStringView* pcFindLabel;
		CStringView* pcReplaceLabel;
};


#endif
