//  AEdit 0.5.1 -:-  (C)opyright 2000-2001 Kristian Van Der Vliet
//
// This is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include "gotodialog.h"
#include "messages.h"

GotoDialog::GotoDialog(const CRect& cFrame, CWindow* pcParent) : CWindow(cFrame, "Goto Line", WT_UNTYPED_WINDOW, WND_NO_ZOOM_BUT | WND_NO_DEPTH_BUT | WND_NOT_RESIZABLE)
{
	pcParentWindow=pcParent;		// We need to know the parent window so we can send messages back to it

	// Create the Layoutviews

	pcMainLayoutView=new GotoLayoutView(Bounds());
	
	// Add the View to the Window

	AddChild(pcMainLayoutView);
}

void GotoDialog::MessageReceived(CMessage* pcMessage)
{
	switch(pcMessage->what)
	{

		case ID_BUT_GOTO:
		{	
			pcMessage->AddInt32("goto_lineno", pcMainLayoutView->GetLineNo());
			pcParentWindow->PostMessage(pcMessage, pcParentWindow);	// Send the messages from the dialog back to the parent window

			break;
		}

		default:
		{
			pcParentWindow->PostMessage(pcMessage, pcParentWindow);	// Send the messages from the dialog back to the parent window
			break;
		}
	}
}

