//  AEdit 0.5.1 -:-  (C)opyright 2000-2001 Kristian Van Der Vliet
//
// This is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include <interface/Window.h>
#include <stdio.h>
#include "imagebutton.h"


using namespace os;


ImageButton::ImageButton(CRect cFrame, const char* pzName, const char* pzLabel, CMessage* pcMessage) : CButton(cFrame, pzName, pzLabel, pcMessage, CF_FOLLOW_LEFT, WID_WILL_DRAW | WID_FULL_UPDATE_ON_RESIZE)
{
	pcButtonImage = new CBitmap(cFrame.IntegerWidth(), cFrame.IntegerHeight(), CS_RGB32);
}

void ImageButton::Draw( CRect cUpdateRect )
{
	CRect cBounds = Bounds();

	SetViewColor( get_default_color( COL_NORMAL ) );

	if ( Window()->DefaultButton() == this )
	{
		SetHighColor( 0, 0, 0 );
		StrokeLine( CPoint( cBounds.left, cBounds.top ), CPoint( cBounds.right, cBounds.top ) );
		StrokeLine( CPoint( cBounds.right, cBounds.bottom ) );
		StrokeLine( CPoint( cBounds.left, cBounds.bottom ) );
		StrokeLine( CPoint( cBounds.left, cBounds.top ) );
		cBounds.InsetBy(1, 1);
		DrawFrame( cBounds, (Value()) ? FRAME_RECESSED : FRAME_RAISED );
	} 
	else
	{
		DrawFrame( cBounds, (Value()) ? FRAME_RECESSED : FRAME_RAISED );
	}

	CRect cBitmapRect = pcButtonImage->Bounds();
	cBitmapRect.InsetBy(2, 2);
	DrawBitmap(pcButtonImage, cBitmapRect, cBitmapRect);
}

void ImageButton::SetBitmap(uint8* pData, uint iNumBytes)
{
	memcpy( pcButtonImage->LockRaster(), pData, iNumBytes);
}

