/*

	RLFField.cpp

	(c) 1998-99 Robert Lanziner-Furtenbach

*/

#include "RLFDebug.h"
#include "RLFFields.h"
#include <interface/MenuItem.h>

RLFFontField::RLFFontField ( BRect r )
	: BMenuField ( r, "RLFFontField", "Font", PopUp = new BPopUpMenu ( "" ) )
{
	BMenuItem *it;

// create a menuitem for each font_family
	int32 numFamilies = count_font_families();
	for ( int32 i = 0; i < numFamilies; i++ ) {
		font_family localfamily;
		if ( get_font_family ( i, &localfamily ) == B_OK ) {
			PopUp->AddItem ( it = new BMenuItem ( localfamily, new BMessage ( Msg_Font_Changed ) ) );
		}
	}
}

void RLFFontField::SetFontFamily ( font_family family )
{
	BMenuItem *it;

	it = PopUp->FindMarked ();				// first find actual marked family
	if ( it != NULL )
		it->SetMarked ( false );			// and unmark

	it = PopUp->FindItem ( family );		// find family for marking
	if ( it != NULL )
		it->SetMarked ( true );				// and mark
	PopUp->SetLabelFromMarked ( true );
}

void RLFFontField::GetFontFamily ( font_family *family )
{
	BMenuItem *it = PopUp->Superitem();
	strcpy (*family, "" );
	if ( it != NULL ) 
		strcpy ( *family, it->Label() );
}

// ------------------------------------------------------------------------------

RLFFontSize::RLFFontSize ( BRect r, int16 min, int16 max )
	: BMenuField ( r, "RLFFontSize", "Size", PopUp = new BPopUpMenu ( "" ) )
{
	BMenuItem *it;
	char	s[10];
	int16	i;
// swap min,max if min > max
	if ( min > max ) {
		i = min;
		min = max;
		max = i;
	}
// fill popup with integers
	for ( i = min; i <= max; i++ ) {
		sprintf ( s, "%i", i );
		PopUp->AddItem ( it = new BMenuItem ( s, new BMessage ( Msg_Size_Changed ) ) );
	}
}

void RLFFontSize::SetFontSize ( int32 size )
{
	BMenuItem *it;
	char	s[10];

	it = PopUp->FindMarked ();				// first find actual marked family
	if ( it != NULL )
		it->SetMarked ( false );			// and unmark

	sprintf ( s, "%li", size );
	it = PopUp->FindItem ( s );				// find family for marking
	if ( it != NULL )
		it->SetMarked ( true );				// and mark
	PopUp->SetLabelFromMarked ( true );
}

void RLFFontSize::GetFontSize ( int32 *size )
// returns the value the item is set to
{
	int32	i;
	BMenuItem *it = PopUp->Superitem();
	*size = 0;
	if ( it != NULL ) {
		if ( sscanf ( it->Label(), "%li", &i ) == 0 ){
			DEBUG_PRINT ( "RLFFontSIze GetFontSize not OK" );
		}
		*size = i;
	}
}


