/*
	
	RLFSearch.h

	(c) 1998-99 Robert Lanziner-Furtenbach

*/

#ifndef RLF_SEARCH_H
#define RLF_SEARCH_H

#include <interface/Window.h>
#include <TextControl.h>

#define Msg_Search			'FMse'
#define Msg_Replace			'FMre'
#define Msg_ReplaceAll		'FMra'

#define Msg_Find_Change		'FMfc'

extern const char *FindText;
extern const char *ReplaceText;


class RLFSearch : public BWindow  
{
public:
				RLFSearch (BRect frame, const char *title, const char *text, BHandler *_handler, bool do_search );
virtual	void	MessageReceived ( BMessage *message );
virtual void	DispatchMessage ( BMessage *message, BHandler *handler );

private:
		void	ExtractToMsg	( BMessage *message );

	BTextControl	*find;				// field for text to find
	BTextControl	*replacewith;		// field for text to replace with
	BButton			*search;			// buttons for dialog
	BButton			*replace;
	BButton			*replaceall;
	BButton			*cancel;
	BHandler		*handler;			// handler for posting messages
	bool			priv_do_search;		// true if search else replace
};

#endif
