/*
	
	RLFSettings.h

	(c) 1998-99 Robert Lanziner-Furtenbach

*/

#ifndef RLF_SETTING_H
#define RLF_SETTING_H

#include "RLFFields.h"

#include <interface/Window.h>
#include <TextControl.h>
#include <interface/Button.h>


#define Msg_Apply			'FMap'
#define Msg_Revert			'FMre'
#define Msg_Default			'FMde'
#define Msg_Preferences		'FMpr'
#define Msg_FontFamily		'FMff'
#define Msg_Length_Changed	'FMlc'
#define Msg_Disable_Fields	'FMdf'

extern const char *LineLength;
extern const char *FontFamily;
extern const char *FontSize;

class RLFSetting : public BWindow  
{
public:
				RLFSetting (BRect frame, BMessage *_ValueMsg, BMessage *_DefaultMsg );
virtual	void	MessageReceived ( BMessage *message );
virtual void	DispatchMessage ( BMessage *message, BHandler *handler );

private:
		bool	InitByMsg 		( BMessage *message );
		bool	ExtractToMsg	( BMessage *message );

	BMessage		ValueMsg;
	BMessage		DefaultMsg;
	BTextControl	*linelen;
	BButton			*apply;
	BButton			*revert;
	BButton			*Bdefault;
	BButton			*cancel;
	RLFFontField	*FontField;
	RLFFontSize		*FontSizeField;
};

void DefaultSettings	( BMessage *message );			// set default preferences
void LoadSettings		( BMessage *message );			// load the preferences
void SaveSettings		( BMessage *message );			// save the preferences

#endif
