/*
	
	RLFTextView.h
	
	(c) 1998-99 Robert Lanziner-Furtenbach
	
*/

#ifndef RLF_TEXT_VIEW_H
#define RLF_TEXT_VIEW_H

#include <interface/TextView.h>
#include <interface/StringView.h>

class RLFTextView : public BTextView
{
public:
		RLFTextView(BRect frame, BMessage *ValueMsg, BStringView *StatView, entry_ref *ref ); 
					// frame	rectangle in window to display text
					// CharPerLine	max Length of a line calculated out of the char 'M'
					// font			used font for text, best using be_fixed_font
					// color		color for text, when NULL (default) it is black

virtual void 	MessageReceived(BMessage *message);
virtual void	Pulse (void);
					
	void		TextSaved() { unchanged = true; };
					// tell the textview that the text has been saved
	bool		TextChanged	() { return (!unchanged); };
					// returns status of text

	status_t	PageSetup ( const char *DocumentName );
	void		Print ( const char *DocumentName );
	void		LoadFile ( entry_ref *file_ref );

	bool		Find ( const char *txt );
	void		Replace ( const char *findtxt, const char *replacetxt );
	void		ReplaceAll ( const char *findtxt, const char *replacetxt );
	char		*LastSearchString;
	char		*LastReplaceString;
	void		AdjustView ( BMessage *message );

protected:
// overwriting InsertText and DeleteText
// when changes are made to the text there is the message RLF_Save_Enable sent to the parent window
// not for external use
virtual void	InsertText ( const char *text, int32 length, int32 offset, const text_run_array *runs );
virtual void	DeleteText ( int32 start, int32 finish );



private:
	bool			unchanged;					/* true if text is the original */
	BStringView		*StatusView;
	BMessage		*PrintSettings;
	
};

#endif //RLF_TEXT_VIEW_H
