/*
	
	RLFView.cpp
	
	(c) 1998 Robert Lanziner-Furtenbach
	
*/

#include "RLFView.h"

#include <Debug.h>
#include <stdlib.h>
#include <memory.h>
#include <string.h>

#include "RLFMain.h"
#include "RLFWindow.h"

#define DEBUG 1

RLFView::RLFView(BRect rect, int32 CharPerLine, BStringView *StatView, BFont *font, rgb_color *color ) :
	BTextView ( rect, "RLFView", BRect ( 0, 0, font->StringWidth ( "M" ) * (float)CharPerLine + 1, 1 ),
	font, color, B_FOLLOW_ALL_SIDES, B_WILL_DRAW ), StatusView (StatView),
	unchanged (true )
		// textrect is a dummy value, it will be set below
		// set LineWidth to CharPerLine, char M used for max.-length at baseline
{
	SetStylable (false );
}


void RLFView::MessageReceived(BMessage *message)
{
 	switch ( message->what ){
   		case B_SIMPLE_DATA:
   		case B_REFS_RECEIVED:
			if (message->WasDropped() && message->HasRef("refs")) {
				message->what = B_REFS_RECEIVED;	// overwrite in case it is B_SIMPLE_DATA (dropped)
				be_app->PostMessage(message);
   			}
			break;
   		default:
   			// Call inherited if we didn't handle the message
   			BTextView::MessageReceived(message);
   			break;
	}
}

void RLFView::Pulse ( void )
{
	char s [30];
	sprintf ( s, "Line %li", CurrentLine()+1 );
	StatusView->SetText ( s );
	BTextView::Pulse();
}

void RLFView::InsertText ( const char *text, int32 length, int32 offset, const text_run_array *runs )
{
	if ( unchanged == true) {				// if text was original or saved
		unchanged = false;
		Window()->PostMessage ( new BMessage ( RLF_Save_Enable ) );
	}
	BTextView::InsertText ( text, length, offset, runs );
	
}

void RLFView::DeleteText ( int32 start, int32 finish )
{
	if ( unchanged == true) {				// if text was original or saved
		unchanged = false;
		Window()->PostMessage ( new BMessage ( RLF_Save_Enable ) );
	}
	BTextView::DeleteText ( start, finish );
}
