/*
	
	RLFWindow.h
	
	(c) 1998-99 Robert Lanziner-Furtenbach

*/

#ifndef RLF_WINDOW_H
#define RLF_WINDOW_H

#include "RLFTextView.h"
#include <interface/Window.h>
#include <storage/FilePanel.h>
#include <interface/MenuBar.h>

#define File_New				'FFne'			// Menu-Messages
#define File_Open				'FFop'
#define File_Save				'FFsv'
#define File_SaveAs				'FFsa'
#define File_Close				'FFcl'
#define File_Print				'FFpr'
#define File_PageSetup			'FFps'
#define File_Quit				'FFqu'
#define Edit_Find				'FEfi'
#define Edit_Find_Again			'FEfa'
#define Edit_Find_Selection		'FEfs'
#define Edit_Replace			'FEre'
#define Edit_Replace_Same		'FErs'
#define Extra_Settings			'FXse'

#define Msg_Save_Enable			'FMsn'
#define Msg_Unreg_Win			'FMuw'



// DropWindow class
class RLFWindow : public BWindow  
{
public:
				RLFWindow ( BRect frame, entry_ref *ref_, int16 Nr, BMessage *ValueMsg );
virtual	bool	QuitRequested ();
virtual void	MessageReceived ( BMessage *message );
		void	AdaptTitle ( );
		status_t	SaveText ( entry_ref *saveref );
private:
		void	CreateSavePanel();					// create and display a new filepanel for saving
		void	DeleteSavePanel();					// remove the save-filepanel from screen and memory
		RLFTextView		*rlfTextView;
		BMenuBar		*mb;						// menubar of window
		entry_ref		*file_ref;					// reference of directory&filename
		int16			Nr;							// Number of the window
		BFilePanel		*SavePanel;					// Panel for Save and SaveAs
			// a global SavePanel in be_app is not possible because of reentrant calls
			// from different windows
		BMessenger	*Messenger;						// for open&save
};

#endif
