#include <interface/View.h>

namespace os {
  class Spinner;
  class CStringView;
}
using namespace os;

class ColorEdit : public CView
{
public:
    ColorEdit( CRect cFrame, const char* pzName, const Color32_s& sColor );
    void             SetValue( const Color32_s& sColor );
    const Color32_s& GetValue() const;

    virtual void  AllAttached();
    virtual void  FrameResized( float inWidth, float inHeight );
    virtual void  GetPreferredSize( float* outWidth, float* outHeight );
    virtual void  MessageReceived( CMessage* pcMessage );
    virtual void  Draw( CRect cUpdateRect );
  
private:
    Spinner*        m_pcRedSpinner;
    CStringView*    m_pcRedStr;
    Spinner*        m_pcGreenSpinner;
    CStringView*    m_pcGreenStr;
    Spinner*        m_pcBlueSpinner;
    CStringView*    m_pcBlueStr;
    CRect           m_cTestRect;
  
    Color32_s       m_sColor;
};
