#ifndef __F_FONTPANEL_H__
#define __F_FONTPANEL_H__

#include <layoutview.h>
#include <interface/Font.h>

#include <map>

using namespace os;

namespace os {
  class CButton;
  class ListView;
  class Spinner;
  class TextView;
  class CDropDownList;
}

enum
{
  MID_ABOUT,
  MID_HELP,

  MID_LOAD,
  MID_INSERT,
  MID_SAVE,
  MID_SAVE_AS,
  MID_DUP_SEL,
  MID_DELETE_SEL,
  MID_RESTORE,

  MID_SNAPSHOT,
  MID_RESET,
  MID_QUIT,

  GID_COUNT
};

class FontPanel : public os::LayoutView
{
public:
  
    FontPanel( const os::CRect& cFrame );
    virtual void Draw( CRect cUpdateRect );
    virtual void KeyDown( const char* pzString, const char* pzRawString, uint32 nQualifiers );
    virtual void FrameResized( float inWidth, float inHeight );
    virtual void AllAttached();
    virtual void MessageReceived( CMessage* pcMessage );
  
private:
    void UpdateSelectedConfig();

    CRect          m_cTestArea;

    struct ConfigNode {
        std::string         m_cName;
        os::font_properties m_sConfig;
        os::font_properties m_sOrigConfig;
        bool                m_bModified;
    };
    CFont::size_list_t       m_cBitmapSizes;
    std::vector<ConfigNode> m_cConfigList;
    int                     m_nCurSelConfig;
    
    ListView*         m_pcFontList;
    CDropDownList*    m_pcFontConfigList;
    CDropDownList*    m_pcBitmapSizeList;
    Spinner*          m_pcSizeSpinner;

    TextView*         m_pcTestView;
    CButton*          m_pcRescanBut;
    CButton*          m_pcOkBut;
    CButton*          m_pcCancelBut;
};

#endif // __F_FONTPANEL_H__
