#ifndef __F_KEYBOARDPANEL_H_
#define __F_KEYBOARDPANEL_H_

#include <layoutview.h>

#include <vector>
#include <map>

using namespace os;

namespace os {
  class CButton;
  class ListView;
  class CCheckBox;
  class Spinner;
  class CStringView;
}

class ColorEdit;

class KeyboardPanel : public os::LayoutView
{
public:
  
    KeyboardPanel( const os::CRect& cFrame );
    virtual void Draw( CRect cUpdateRect );
    virtual void KeyDown( const char* pzString, const char* pzRawString, uint32 nQualifiers );
    virtual void FrameResized( float inWidth, float inHeight );
    virtual void AllAttached();
    virtual void MessageReceived( CMessage* pcMessage );
  
private:
//    void Layout();
    void UpdateResList();

    struct ColorSpace
    {
        ColorSpace( color_space eMode ) { m_eMode = eMode; }
        bool operator < ( const ColorSpace& cInst ) const { return( m_eMode < cInst.m_eMode ); }
        color_space                   m_eMode;
        std::vector<screen_mode> m_cResolutions;
    };

    std::map<color_space,ColorSpace> m_cColorSpaces;
  
    CButton*        m_pcRefreshBut;
    CButton*        m_pcOkBut;
    CButton*        m_pcCancelBut;
    ListView*       m_pcKeymapList;
    Spinner*        m_pcKeyDelay;
    Spinner*        m_pcKeyRepeat;
    
};

#endif // __F_KEYBOARDPANEL_H_
