#ifndef __F_SCREENPANEL_H_
#define __F_SCREENPANEL_H_

#include <layoutview.h>

#include <vector>
#include <map>

using namespace os;

namespace os {
  class CButton;
  class ListView;
  class CCheckBox;
  class CDropDownList;
  class Spinner;
  class CStringView;
}

class ScreenPanel : public os::LayoutView
{
public:
  
    ScreenPanel( const os::CRect& cFrame );
    virtual void Draw( CRect cUpdateRect );
    virtual void KeyDown( const char* pzString, const char* pzRawString, uint32 nQualifiers );
    virtual void FrameResized( float inWidth, float inHeight );
    virtual void AllAttached();
    virtual void MessageReceived( CMessage* pcMessage );
  
private:
    void UpdateResList();

    struct ColorSpace
    {
        ColorSpace( color_space eMode ) { m_eMode = eMode; }
        bool operator < ( const ColorSpace& cInst ) const { return( m_eMode < cInst.m_eMode ); }
        color_space                   m_eMode;
        std::vector<screen_mode> m_cResolutions;
    };

    screen_mode m_sOriginalMode;
    screen_mode m_sCurrentMode;
    
    std::map<color_space,ColorSpace> m_cColorSpaces;
  
    CButton*         m_pcOkBut;
    CButton*         m_pcCancelBut;
    CCheckBox*       m_pcAllCheckBox;
    CDropDownList*   m_pcColorSpaceList;
    Spinner*         m_pcRefreshRate;

    CStringView*     m_pcColorSpaceStr;
    CStringView*     m_pcRefreshRateStr;
  
    ListView*        m_pcModeList;
};

#endif // __F_SCREENPANEL_H_
