#ifndef __F_WINDOWPANEL_H_
#define __F_WINDOWPANEL_H_

#include <layoutview.h>

#include <vector>
#include <map>

using namespace os;

namespace os {
  class CButton;
  class ListView;
  class CCheckBox;
  class CDropDownList;
  class Spinner;
  class CStringView;
}

class ColorEdit;

class WindowPanel : public LayoutView
{
public:
  
    WindowPanel( const os::CRect& cFrame );
    
    virtual void  Draw( CRect cUpdateRect );
    virtual void  KeyDown( const char* pzString, const char* pzRawString, uint32 nQualifiers );
    virtual void  FrameResized( float inWidth, float inHeight );
    virtual void  AllAttached();
    virtual void  MessageReceived( CMessage* pcMessage );
  
private:
//    void Layout();
    void UpdateDecoratorList();

    struct ColorSpace
    {
        ColorSpace( color_space eMode ) { m_eMode = eMode; }
        bool operator < ( const ColorSpace& cInst ) const { return( m_eMode < cInst.m_eMode ); }
        color_space                   m_eMode;
        std::vector<screen_mode> m_cResolutions;
    };

    std::map<color_space,ColorSpace> m_cColorSpaces;
  
    CButton*            m_pcRefreshBut;
    CButton*            m_pcOkBut;
    CButton*            m_pcCancelBut;
    ListView*           m_pcDecoratorList;
    CDropDownList*		m_pcPenMenu;
    ColorEdit*          m_pcColorEdit;
    CCheckBox*          m_pcPopupWndCheckBox;
};

#endif // __F_WINDOWPANEL_H_
