//****************************************************************************************
//
//	File:		PulseView.h
//
//	Written by:	David Ramsey and Daniel Switkin
//
//	Copyright 1999, Be Incorporated
//
//	Revised by: Steffen Yount
//
//****************************************************************************************

#ifndef PULSEVIEW_H
#define PULSEVIEW_H

#include <interface/View.h>
#include <interface/PopUpMenu.h>
#include <interface/MenuItem.h>
#include "Common.h"
#include "PulseApp.h"
#include "Prefs.h"


class PulseView : public BView
{
	public:
		PulseView(BRect rect, const char *name);
		~PulseView();
		virtual void MouseDown(BPoint point);

	protected:
		void Update();

		double cpu_times[B_MAX_CPU_COUNT];
		bigtime_t prev_active[B_MAX_CPU_COUNT];
		bigtime_t prev_time;
		
		Prefs * prefs;

		float priority_times[P_PRIORITY_COUNT];
		bigtime_t prev_priority_active[P_PRIORITY_COUNT];

};


#endif

