/*
 *  The Cosmoe application server
 *  Copyright (C) 1999 - 2001 Kurt Skauen
 *  Copyright (C) 2002 Bill Hayden
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

 
#include <support/SupportDefs.h>

#include <interface/InterfaceDefs.h>
#include <util/resource.h>
#include <util/array.h>


struct       ModeInfo_s;
class        DisplayDriver;


class SrvBitmap : public Resource
{
public:
					SrvBitmap( int nWidth,
							   int nHeight,
							   os::ColorSpace eColorSpc,
							   uint8* pRaster = NULL,
							   int nBytesPerLine = 0 );

	area_id			m_hArea;
	uint32			m_nFlags;
	bool			m_bFreeRaster;    // true if the raster memory is allocated by the constructor
	int				m_nWidth;
	int				m_nHeight;
	int				m_nBytesPerLine;
	os::ColorSpace  m_eColorSpc;
	uint8*			m_pRaster;        // adress of frame buffer
	DisplayDriver*	m_pcDriver;
	bool			m_bVideoMem;
	
protected:
					~SrvBitmap();
};

class BitmapNode
{
public:
				BitmapNode( SrvBitmap* pcBitmap );
				~BitmapNode();

	int			GetToken( void ) const  { return( m_hHandle ); }

	SrvBitmap*	m_pcBitmap;

private:
	int			m_hHandle;
};


extern Array<BitmapNode>* g_pcBitmaps;
