/*
 *  The Cosmoe application server
 *  Copyright (C) 1999 - 2001 Kurt Skauen
 *  Copyright (C) 2002 Bill Hayden
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __DESKTOP_H__
#define __DESKTOP_H__

#include "swindow.h"


bool init_desktops();

void set_desktop_config( int nDesktop, const os::screen_mode& sMode, const std::string& cBackDropPath );
int  get_desktop_config( int* pnActiveDesktop, os::screen_mode* psMode, std::string* pcBackdropPath );
void set_desktop_screenmode( int nDesktop, const os::screen_mode& sMode );

int get_active_desktop();

SrvWindow* get_active_window( bool bIgnoreSystemWindows );
void set_active_window( SrvWindow* pcWindow, bool bNotifyPrevious = true );

void add_window_to_desktop( SrvWindow* pcWindow );
void remove_window_from_desktop( SrvWindow* pcWindow );
void set_desktop( int nNum );
bool toggle_desktops();

//void set_desktop_screenmode( int nDesktop, int nWidth, int nHeight, os::color_space eColorSpace, float vRefreshRate,
//                             float vHPos, float vVPos, float vHSize, float vVSize );

#endif // __DESKTOP_H__
