#ifndef        __F_DFBDRIVER_H__
#define        __F_DFBDRIVER_H__

#include "ddriver.h"

#include <directfb.h>


class DirectFBDriver : public DisplayDriver
{
public:

	DirectFBDriver();
	~DirectFBDriver();

	area_id			Open();
	void			Close();

	virtual int		GetScreenModeCount();
	virtual bool	GetScreenModeDesc( int nIndex, ScreenMode* psMode );

	int				SetScreenMode( int nWidth, int nHeight,
									os::color_space eColorSpc,
									int nPosH, int nPosV,
									int nSizeH, int nSizeV,
									float vRefreshRate );

	virtual int		GetHorizontalRes();
	virtual int		GetVerticalRes();
	virtual int		GetBytesPerLine();
	virtual os::color_space GetColorSpace();
	virtual int		GetFramebufferOffset() { return( 0 ); }

	void			SetColor( int nIndex, const os::Color32_s& sColor );

	virtual void	SetCursorBitmap( os::mouse_ptr_mode eMode, const os::IPoint& cHotSpot, const void* pRaster, int nWidth, int nHeight );

	virtual bool	BeginDirectAccess();
	virtual void	EndDirectAccess();

	virtual void	MouseOn();
	virtual void	MouseOff();
	virtual void	SetMousePos( os::IPoint cNewPos );
	bool			IntersectWithMouse( const os::IRect& cRect );

	bool			DrawLine( SrvBitmap* psBitMap, const os::IRect& cClipRect,
							const os::IPoint& cPnt1, const os::IPoint& cPnt2, const os::Color32_s& sColor, int nMode );
	bool			FillRect( SrvBitmap* psBitMap, const os::IRect& cRect, const os::Color32_s& sColor );
	bool			BltBitmap( SrvBitmap* pcDstBitMap, SrvBitmap* pcSrcBitMap, os::IRect cSrcRect, os::IPoint cDstPos, int nMode );

private:
    bool			InitModes();

	int					m_nCurrentMode;
	uint32				m_nFrameBufferSize;
	std::vector<ScreenMode> mModeList;

	IDirectFB*			mFrameBuffer;
	IDirectFBSurface*	mPrimarySurface;
};

#endif
