#include <stdio.h>
#include <assert.h>
#include <ctype.h>
#include <malloc.h>
#include <string.h>

#include <cosmoe/kernel.h>

#include <appserver/keymap.h>

int load_keymap( FILE* hFile, keymap* psKeymap )
{
	uint32 anHeader[2];

	if ( fread( anHeader, sizeof(uint32), 2, hFile ) != 2 )
	{
		dbprintf( "Error: Failed to read keymap header\n" );
		return( -1 );
	}
	
	if ( anHeader[0] != KEYMAP_MAGIC )
	{
		dbprintf( "Error: Keymap have bad magic number (%08x) should have been %08x\n", anHeader[0], KEYMAP_MAGIC );
		return( -1 );
	}

	if ( anHeader[1] != CURRENT_KEYMAP_VERSION )
	{
		dbprintf( "Error: Unknown keymap version %d\n", anHeader[1] );
		return( -1 );
	}

	if ( fread( psKeymap, sizeof(*psKeymap), 1, hFile ) == 1 )
	{
		return( 0 );
	}
	else
	{
		dbprintf( "Error: Failed to read keymap\n" );
		return( -1 );
	}
}

