#ifndef __F_WINDOWDECORATOR_H__
#define __F_WINDOWDECORATOR_H__

#include <support/SupportDefs.h>
#include <interface/Region.h>

class Layer;

namespace os {

  enum { WNDDECORATOR_APIVERSION = 4 };
  
class WindowDecorator
{
public:
    enum hit_item { HIT_NONE, HIT_CLOSE, HIT_ZOOM, HIT_DEPTH, HIT_DRAG, HIT_SIZE_LEFT, HIT_SIZE_TOP,
                    HIT_SIZE_RIGHT, HIT_SIZE_BOTTOM, HIT_SIZE_LT, HIT_SIZE_RT, HIT_SIZE_LB, HIT_SIZE_RB };
  
    WindowDecorator( Layer* pcLayer, uint32 nWndFlags );
    virtual ~WindowDecorator();
  
    Layer* GetLayer() const;

    virtual hit_item HitTest( const CPoint& cPosition ) = 0;
    virtual void FrameSized( const CRect& cNewFrame ) = 0;
    virtual CRect GetBorderSize() = 0;
    virtual CPoint GetMinimumSize() = 0;
    virtual void SetTitle( const char* pzTitle ) = 0;
    virtual void SetFlags( uint32 nFlags ) = 0;
    virtual void FontChanged() = 0;
    virtual void SetWindowFlags( uint32 nFlags ) = 0;
    virtual void SetFocusState( bool bHasFocus ) = 0;
    virtual void SetCloseButtonState( bool bPushed ) = 0;
    virtual void SetZoomButtonState( bool bPushed ) = 0;
    virtual void SetDepthButtonState( bool bPushed ) = 0;
    virtual void Render( const CRect& cUpdateRect ) = 0;
private:
    Layer* m_pcLayer;
};

typedef int op_get_decorator_version();
typedef WindowDecorator* op_create_decorator( Layer* pcView, uint32 nFlags );

}

#endif // __F_WINDOWDECORATOR_H__
