/*  libcosmoe.so - the interface to the Cosmoe UI
 *  Portions Copyright (C) 2001-2002 Bill Hayden
 *  Portions Copyright (C) 1999-2001 Kurt Skauen
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2 as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA
 */


#ifndef __CLIPBOARD_H__
#define __CLIPBOARD_H__


#include <app/Message.h>
#include <support/Locker.h>

#include <string>

#define BClipboard		os::CClipboard
// Looking for be_clipboard?  It's in <Application.h>.

namespace os
{

/** 
 * \ingroup app
 * \par Description:
 *
 * \sa
 * \author	Kurt Skauen (kurt@atheos.cx), Bill Hayden (hayden@haydentech.com)
 *****************************************************************************/

class CClipboard
{
public:
				CClipboard();
				CClipboard( const char* pzName );
				~CClipboard();
	
	const char*	Name() const { return m_cName.c_str(); }

	bool		Lock();
	void		Unlock();
	bool		IsLocked() const;

	void		Clear();
	void		Commit();

	CMessage*	Data();
//  status_t SetData( CMessage* pcBuffer );
  
private:
	CLocker		m_cMutex;
	std::string	m_cName;
	port_id		m_hServerPort;
	port_id		m_hReplyPort;
	CMessage	m_cBuffer;
	bool		m_bCleared;
};



}
#endif
