/*  libcosmoe.so - the interface to the Cosmoe UI
 *  Portions Copyright (C) 2001-2002 Bill Hayden
 *  Portions Copyright (C) 1999-2001 Kurt Skauen
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2 as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA
 */

 
#ifndef	__INVOKER_H__
#define	__INVOKER_H__


#include <sys/types.h>
#include <app/Messenger.h>

namespace os
{

class	CMessage;
class	CHandler;
class	CLooper;

/** 
 * \ingroup app
 * \par Description:
 *
 * \sa
 * \author	Kurt Skauen (kurt@atheos.cx), Bill Hayden (hayden@haydentech.com)
 *****************************************************************************/

class CInvoker
{
public:
						CInvoker();
						CInvoker( CMessage* pcMessage );
						CInvoker( CMessage* pcMessage,
								  const CHandler* pcHandler,
								  const CLooper* pcLooper = NULL );
					//  CInvoker( CMessage* pcMessage, const Looper* pcLooper );
						CInvoker( CMessage* pcMessage, const CMessenger& cTarget );
	
	virtual				~CInvoker();

	virtual status_t	SetMessage( CMessage* pcMessage );
	CMessage*			Message() const;
	uint32				Command() const;

	virtual bool 		Invoked( CMessage* pcMessage );
	virtual void 		TargetChanged( const CMessenger& cOldTarget );
	virtual void 		MessageChanged( const CMessage& cOldMsg );

	virtual status_t	SetTarget( const CHandler* pcHandler, const CLooper* pcLooper = NULL );
	virtual status_t	SetTarget( CMessenger cMessenger );
	bool				IsTargetLocal() const;
	CHandler*			Target( CLooper** ppcLooper = NULL ) const;
	CMessenger			Messenger() const;
	virtual status_t	SetHandlerForReply( CHandler* pcHandler );
	CHandler*			GetHandlerForReply() const;
	virtual status_t	Invoke( CMessage* inMessage = NULL );

private:
	CMessage*			mMessage;
	CMessenger			m_cMessenger;
	CHandler*			m_pcReplyTo;
};

}

#endif
