/*  libcosmoe.so - the interface to the Cosmoe UI
 *  Portions Copyright (C) 2001-2002 Bill Hayden
 *  Portions Copyright (C) 1999-2001 Kurt Skauen
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2 as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA
 */

 
#ifndef	__MESSAGEQUEUE_H__
#define	__MESSAGEQUEUE_H__

#include <support/SupportDefs.h>
#include <support/Locker.h>

#define BMessageQueue	os::CMessageQueue

namespace os
{

class	CMessage;

/** 
 * \ingroup app
 * \par Description:
 *
 * \sa
 * \author	Kurt Skauen (kurt@atheos.cx), Bill Hayden (hayden@haydentech.com)
 *****************************************************************************/

class CMessageQueue
{
public:
				CMessageQueue();
	virtual		~CMessageQueue();

	void		AddMessage( CMessage* pcMsg );
	CMessage*	NextMessage();
	bool		RemoveMessage( CMessage* pcMsg );	// NOTE : The message will be deleted if found!
	CMessage*	FindMessage( int nIndex ) const;
	CMessage*	FindMessage( uint32 nCode, int nIndex = 0 ) const;
	int32		CountMessages( void ) const;
	bool		IsEmpty( void ) const;

	bool		Lock( void );
	void		Unlock( void );
private:
//  sem_id		m_hSemaphore;
	CLocker		m_cMutex;
	CMessage*	m_pcFirstMessage;
	CMessage*	m_pcLastMessage;
	int			m_nMsgCount;
};

}
#endif	//	__MESSAGEQUEUE_H__
