/*  libcosmoe.so - the interface to the Cosmoe UI
 *  Copyright (C) 2001-2002 Bill Hayden
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2 as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA
 */

 
#ifndef _MESSAGERUNNER_H
#define _MESSAGERUNNER_H

#include <app/Messenger.h>
#include <app/Handler.h>

#define BMessageRunner	os::CMessageRunner


namespace os {

class CMessageRunner
{
public:
					CMessageRunner( CMessenger target,
									const CMessage *msg,
									bigtime_t inInterval,
									int32 inCount = -1 );
					CMessageRunner( CMessenger target,
									const CMessage *msg,
									bigtime_t inInterval,
									int32 inCount,
									CMessenger reply_to );
	virtual			~CMessageRunner();

	status_t		InitCheck() const;

	status_t		SetInterval(bigtime_t inInterval);
	status_t		SetCount(int32 inCount);
	status_t		GetInfo(bigtime_t *outInterval, int32 *outCount) const;

private:

	virtual	void	FBC_MessageRunner1();
	virtual	void	FBC_MessageRunner2();
	virtual	void	FBC_MessageRunner3();
	virtual	void	FBC_MessageRunner4();
	virtual	void	FBC_MessageRunner5();
	virtual	void	FBC_MessageRunner6();

	static uint32	_Entry( void* pData );
	void			_Loop( void );
	
	bigtime_t		mInterval;
	int32			mCount;
	uint32			_reserved[6];
	thread_id		mThread;
	CMessenger		mTarget;
	CMessenger		mReplyTo;
	const CMessage*	mMessage;
};

}
#endif 


