/*  libcosmoe.so - the interface to the Cosmoe UI
 *  Portions Copyright (C) 2001-2002 Bill Hayden
 *  Portions Copyright (C) 1999-2001 Kurt Skauen
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2 as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA
 */


#ifndef	__BOX_H__
#define	__BOX_H__


#define BBox		os::CBox

#include <layoutview.h>
#include <interface/Font.h>

namespace os
{


class CBox : public LayoutView
{
public:
					CBox( CRect inFrame,
						  const char* inName,
						  const char* cLabel,
						  uint32 inResizeMask = CF_FOLLOW_LEFT | CF_FOLLOW_TOP,
						  uint32 inFlags = WID_WILL_DRAW | WID_CLEAR_BACKGROUND );

	void			SetLabel( const char* cLabel );
	CView*			SetLabel( CView* pcLabel, bool bResizeToPreferred = true );
	const char*		Label() const;
	CView*			LabelView() const;

	virtual void	AttachedToWindow();
	virtual void	FrameResized( float inWidth, float inHeight );
	virtual void	FontChanged( CFont* pcNewFont );
	virtual void	Draw( CRect cUpdateRect );

	virtual void	GetPreferredSize( float* outWidth, float* outHeight );

private:
	void			_CalcStringLabelSize();

	CPoint			m_cLabelSize;
	font_height		m_sFontHeight;
	CView*			m_pcLabelView;
	std::string		m_cLabelString;

	uint32			__reserved[6];
};


} // end of namespace


#endif
