/*  libcosmoe.so - the interface to the Cosmoe UI
 *  Portions Copyright (C) 2001-2002 Bill Hayden
 *  Portions Copyright (C) 1999-2001 Kurt Skauen
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2 as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA
 */


#ifndef	__CHECKBOX_H__
#define	__CHECKBOX_H__

#include <interface/Control.h>

namespace os
{

/** 2-state check box.
 * \ingroup interface
 * \par Description:
 *
 * \sa
 * \author	Kurt Skauen (kurt@atheos.cx), Bill Hayden (hayden@haydentech.com)
 *****************************************************************************/

class CCheckBox : public CControl
{
public:
					CCheckBox( CRect cFrame,
							   const char* pzName,
							   const char* pzLabel,
							   CMessage* pcMessage,
							   uint32 nResizeMask = CF_FOLLOW_LEFT | CF_FOLLOW_TOP,
							   uint32 inFlags = WID_WILL_DRAW |
												WID_CLEAR_BACKGROUND );
					~CCheckBox();

	// From view

	virtual void	GetPreferredSize( float* outWidth, float* outHeight );
	virtual void	MouseDown( CPoint cPosition );
	virtual void	MouseUp( CPoint cPosition );
	virtual void	Draw( CRect cUpdateRect );

	virtual void	PostValueChange( const Variant& cNewValue );
	virtual void	LabelChanged( const std::string& cNewLabel );
	virtual void	EnableStatusChanged( bool bIsEnabled );
	virtual bool	Invoked( CMessage* pcMessage );
};

}

#endif	//	__CHECKBOX_H__
