/*  libcosmoe.so - the interface to the Cosmoe UI
 *  Portions Copyright (C) 2001-2002 Bill Hayden
 *  Portions Copyright (C) 1999-2001 Kurt Skauen
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2 as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA
 */

#ifndef __MENUBAR_H__
#define __MENUBAR_H__

#include <interface/Menu.h>

#define BMenuBar	os::CMenuBar

namespace os
{

class CMenuBar : public CMenu
{
public:
			CMenuBar(	CRect		 inFrame,
						const char*  inTitle,
						uint32		 inResizeMask = CF_FOLLOW_LEFT_RIGHT |
													CF_FOLLOW_TOP,
						MenuLayout_e inLayout = ITEMS_IN_ROW,
						bool inResizeToFit = true );
virtual		~CMenuBar();
};

inline CMenuBar::CMenuBar(CRect inFrame,
						  const char *inTitle,
						  uint32 inResizeMask,
						  MenuLayout_e inLayout,
						  bool inResizeToFit) :
							CMenu(inFrame, inTitle, inResizeMask, 0UL, inLayout, inResizeToFit)
{
}

}


#endif
