/*  libcosmoe.so - the interface to the Cosmoe UI
 *  Copyright (C) 2002 Bill Hayden
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2 as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA
 */

 
#ifndef __POPUPMENU_H__
#define __POPUPMENU_H__

#include <interface/Menu.h>

#define BPopUpMenu		os::CPopUpMenu

namespace os
{


class CPopUpMenu : public CMenu
{
public:
						CPopUpMenu(	const char *inName,
									bool inRadioMode = true,
									bool inAutoRename = true,
									MenuLayout_e inLayout = ITEMS_IN_COLUMN );
virtual					~CPopUpMenu();

	CMenuItem*			Go( CPoint where,
							bool delivers_message = false,
							bool open_anyway = false,
							bool async = false);
	CMenuItem*			Go( CPoint where,
							bool delivers_message,
							bool open_anyway,
							CRect click_to_open,
							bool async = false );

	virtual void		MessageReceived( CMessage *msg );
	virtual	void		MouseDown( CPoint pt );
	virtual	void		MouseUp( CPoint pt );
	virtual	void		MouseMoved( CPoint pt, uint32 code, const CMessage *msg );
	virtual	void		AttachedToWindow();
	virtual	void		DetachedFromWindow();
	virtual	void		FrameMoved( CPoint new_position );
	virtual	void		FrameResized( float new_width, float new_height );

	virtual void		ResizeToPreferred();
	virtual void		GetPreferredSize( float *outWidth, float *outHeight );
	virtual void		MakeFocus( bool state = true );
	virtual void		AllAttached();
	virtual void		AllDetached();

	//void				SetAsyncAutoDestruct(bool state);
	//bool				AsyncAutoDestruct() const;

protected:

	virtual	CPoint		ScreenLocation();

	virtual	void		FBC_PopUpMenu1();
	virtual	void		FBC_PopUpMenu2();
	virtual	void		FBC_PopUpMenu3();

	//CPopUpMenu&			operator=(const CPopUpMenu &);

private:

	CPoint				mWhere;
	bool				mUseWhere;
	bool				mAutoDestruct;
	bool				mAutoRename;
//	thread_id			mTrackingThread;
	uint32				FBC_Reserved[3];
};

}


#endif // __POPUPMENU_H__
