/*  libcosmoe.so - the interface to the Cosmoe UI
 *  Portions Copyright (C) 2001-2002 Bill Hayden
 *  Portions Copyright (C) 1999-2001 Kurt Skauen
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2 as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA
 */


#ifndef	__PROGRESSBAR_H__
#define	__PROGRESSBAR_H__


#include <interface/View.h>


namespace os
{

/** 
 * \ingroup gui
 * \par Description:
 *
 * \sa
 * \author	Kurt Skauen (kurt@atheos.cx)
 *****************************************************************************/

class ProgressBar : public CView
{
public:
					ProgressBar( CRect inFrame,
								 const char* inTitle,
								 orientation eOrientation = HORIZONTAL,
								 uint32 inResizeMask = CF_FOLLOW_LEFT | CF_FOLLOW_TOP,
								 uint32 inFlags = WID_WILL_DRAW | WID_CLEAR_BACKGROUND );

	void			SetProgress( float vValue );
	float			GetProgress() const;

	virtual void	GetPreferredSize( float* outWidth, float* outHeight );

	virtual void	AttachedToWindow();
	virtual void	Draw( CRect cUpdateRect );
	virtual void	FrameResized( float inWidth, float inHeight );


private:
	float			m_vProgress;
	orientation		m_eOrientation;
	int32			FBC_Reserved[16];
};



} // end of namespace

#endif // __PROGRESSBAR_H__
