/*  libcosmoe.so - the interface to the Cosmoe UI
 *  Portions Copyright (C) 2001-2002 Bill Hayden
 *  Portions Copyright (C) 1999-2001 Kurt Skauen
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2 as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA
 */


#ifndef __REQUESTERS_H__
#define __REQUESTERS_H__

#include <stdarg.h>

#include <vector>
#include <string>

#include <interface/Window.h>
#include <interface/Bitmap.h>
#include <interface/StringView.h>
#include <interface/Button.h>
#include <app/Message.h>


namespace os
{

class ProgressView : public CView
{
public:
					ProgressView( CRect cFrame, bool bCanSkip );
	void			Layout( const CRect& cBounds );

	virtual void	Draw( CRect cUpdateRect );
	virtual void	FrameResized( float inWidth, float inHeight );

private:
	friend class ProgressRequester;
	CStringView*	m_pcPathName;
	CStringView*	m_pcFileName;
	CButton*		m_pcCancel;
	CButton*		m_pcSkip;
};


class ProgressRequester : public CWindow
{
public:
	enum { IDC_CANCEL = 1, IDC_SKIP };

					ProgressRequester( CRect inFrame,
									   const char* pzTitle,
									   bool bCanSkip );

	virtual void	MessageReceived( CMessage* pcMessage );

	void			SetPathName( const char* pzString );
	void			SetFileName( const char* pzString );

	bool			DoCancel() const;
	bool			DoSkip();

private:
	ProgressView*	m_pcProgView;
	volatile bool	m_bDoCancel;
	volatile bool	m_bDoSkip;
};

}
#endif // __REQUESTERS_H__
