/*  libcosmoe.so - the interface to the Cosmoe UI
 *  Portions Copyright (C) 2001-2002 Bill Hayden
 *  Portions Copyright (C) 1999-2001 Kurt Skauen
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2 as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA
 */


#ifndef __SCREEN_H__
#define __SCREEN_H__

#include <support/SupportDefs.h>

#include <interface/Region.h>
#include <interface/InterfaceDefs.h>

#define BScreen				os::CScreen
#define B_MAIN_SCREEN_ID	os::CScreen::ACTIVE_DESKTOP


namespace os {

class CWindow;

/** Class for manipulating virtual desktops.
 * \ingroup interface
 * \par Description:
 *
 * \author	Kurt Skauen (kurt@atheos.cx), Bill Hayden (hayden@haydentech.com)
 *****************************************************************************/

class CScreen
{
public:
	enum { ACTIVE_DESKTOP = 9999 };

				CScreen( int inScreen = ACTIVE_DESKTOP );
				CScreen( CWindow*	inWindow );
				~CScreen();

	screen_mode GetScreenMode() const;
	IPoint		GetResolution() const;
	CRect		Frame() const;
	color_space	ColorSpace() const;
	void*		GetFrameBuffer();
	bool		SetScreenMode( screen_mode* psMode );
	bool		SetResoulution( int nWidth, int nHeight );
	bool		SetColorSpace( color_space eColorSpace );
	bool		SetRefreshRate( float vRefreshRate );

private:
	int			m_nCookie;
	int			m_nScreen;
	screen_mode* m_psScreenMode;
	void*		m_pFrameBuffer;
	uint32		unused[6];

	area_id		m_hServerAreaID;
	area_id		m_hLocalAreaID;
};

}



#endif
