/*  libcosmoe.so - the interface to the Cosmoe UI
 *  Portions Copyright (C) 2001-2002 Bill Hayden
 *  Portions Copyright (C) 1999-2001 Kurt Skauen
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2 as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA
 */


#ifndef	__STRINGVIEW_H__
#define	__STRINGVIEW_H__

#include <support/SupportDefs.h>
#include <interface/View.h>

#define BStringView	os::CStringView

namespace os
{

/** 
 * \ingroup interface
 * \par Description:
 *
 * \sa
 * \author	Kurt Skauen (kurt@atheos.cx), Bill Hayden (hayden@haydentech.com)
 *****************************************************************************/

class CStringView : public CView
{
public:
					CStringView( CRect cFrame,
								 const char* pzName,
								 const char* pzString,
								 uint32 nResizeMask = CF_FOLLOW_LEFT | CF_FOLLOW_TOP,
								 uint32 nFlags  = WID_WILL_DRAW | WID_FULL_UPDATE_ON_RESIZE );
					~CStringView();

	void			SetMinPreferredSize( int nWidthChars );
	void			SetMaxPreferredSize( int nWidthChars );

	virtual void	GetPreferredSize( float* outWidth, float* outHeight );

	virtual void	Draw( CRect cUpdateRect );

	// From StringView:

	void			SetText( const char* pzString );
	const char*	 	Text( void ) const;

	void	 		SetAlignment( alignment eAlign )	{ m_eAlign = eAlign; }
	alignment		GetAlignment( void ) const			{ return m_eAlign; }
	virtual void	AttachedToWindow();

private:
	struct data {
//	char*       m_pzString;
	std::string m_cString;
	int	    m_nMinSize;
	int	    m_nMaxSize;
	}* m;
	alignment	m_eAlign;
};

}

#endif	//	__STRINGVIEW_H__
