/*  libcosmoe.so - the interface to the Cosmoe UI
 *  Copyright (C) 2001-2002 Bill Hayden
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2 as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA
 */


#ifndef __ENTRYLIST_H__
#define __ENTRYLIST_H__

#include <string>

#define BEntryList		os::CEntryList

namespace os
{

class CEntry;

class CEntryList
{
public:
	virtual 			~CEntryList() {}

	virtual status_t	GetNextEntry( CEntry* inRef, bool inTraverse=false ) = 0;
	virtual status_t	GetNextEntryName( std::string* inName ) { return -1; };
	virtual status_t	Rewind() = 0;
};


}

#endif
