/*  libcosmoe.so - the interface to the Cosmoe UI
 *  Copyright (C) 2001-2002 Bill Hayden
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2 as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA
 */

#ifndef __MIMETYPE_H__
#define __MIMETYPE_H__

#include <support/SupportDefs.h>
#include <string>

#define BMimeType		os::CMimeType
#define icon_size		os::IconSize
#define B_LARGE_ICON	os::kLargeIconSize
#define B_MINI_ICON		os::kSmallIconSize

namespace os
{

enum IconSize
{
	kLargeIconSize = 32,
	kSmallIconSize = 16
};


class CMimeType
{
public:

					CMimeType();
					CMimeType(const char *inMimeType);
	virtual			~CMimeType();

	status_t		SetTo(const char *inMimeType);
	void			Unset();
	status_t		InitCheck() const;

	const char*		Type() const;
	bool			IsValid() const;
	bool			IsSupertypeOnly() const;

	status_t		GetSupertype(CMimeType* outSuperType) const;
	bool			operator==(const CMimeType& inMimeType) const;
	bool			operator==(const char* inMimeType) const;
	bool			Contains(const CMimeType* inMimeType) const;

	static	bool	IsValid(const char *string);

private:

	std::string		mType;
	status_t		mStatus;
};

}

#endif /* __MIMETYPE_H__ */
