/*  libcosmoe.so - the interface to the Cosmoe UI
 *  Copyright (C) 2002 Bill Hayden
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2 as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA
 */


#ifndef __NODEINFO_H__
#define __NODEINFO_H__

#include <storage/File.h>

#define BNodeInfo	os::CNodeInfo

namespace os
{

class CNodeInfo
{
public:
					CNodeInfo()				{ mNode = NULL; mInitCheck = EINVAL; }
					CNodeInfo(CNode* node)	{ mNode = node; mInitCheck = EOK;    }
	virtual			~CNodeInfo()			{}

	status_t		SetTo(CNode* node)		{ mNode = node; mInitCheck = EOK;    }
	status_t		InitCheck() const		{ return mInitCheck;                 }
	
private:
	virtual	void	FBC_NodeInfo1()		{}
	virtual	void	FBC_NodeInfo2()		{}
	
	status_t		mInitCheck;
	CNode*			mNode;
};

}


#endif

