/*  libcosmoe.so - the interface to the Cosmoe UI
 *  Portions Copyright (C) 2001-2002 Bill Hayden
 *  Portions Copyright (C) 1999-2001 Kurt Skauen
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2 as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA
 */


#ifndef __STATABLE_H__
#define __STATABLE_H__

#include <sys/types.h>
#include <sys/stat.h>
#include <support/SupportDefs.h>


namespace os {

struct NodeRef;
class CVolume;

class CStatable
{
public:

	virtual status_t	GetStat(struct stat* outStat) const = 0;

	bool				IsFile() const;
	bool				IsDirectory() const;
	bool				IsSymLink() const;

	status_t			GetNodeRef(NodeRef *ioRef) const;

	status_t 			GetOwner(uid_t *owner) const;
//	status_t			SetOwner(uid_t owner);

	status_t			GetGroup(gid_t *group) const;
//	status_t			SetGroup(gid_t group);

	status_t			GetPermissions(mode_t *perms) const;
//	status_t			SetPermissions(mode_t perms);

	virtual status_t	GetSize(off_t* outSize) const;

	status_t			GetModificationTime(time_t *mtime) const;
//	status_t			SetModificationTime(time_t mtime);

	status_t			GetCreationTime(time_t *ctime) const;
//	status_t			SetCreationTime(time_t ctime);

	status_t			GetAccessTime(time_t *atime) const;
//	status_t			SetAccessTime(time_t atime);

	status_t			GetVolume(CVolume *vol) const;

	ino_t				GetInode() const;

private:

friend class CEntry;
friend class CNode;

//	virtual	status_t	set_stat(struct stat &st, uint32 what) = 0;
};

}

#endif
