/*  libcosmoe.so - the interface to the Cosmoe UI
 *  Copyright (C) 2001-2002 Bill Hayden
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2 as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA
 */

 
// This file is provided strictly for BeOS API compatibility.  It
// contains no "native" defines for Cosmoe.


#ifndef __STORAGEDEFS_H__
#define	__STORAGEDEFS_H__

#include <support/SupportDefs.h>
#include <limits.h>


#define B_FILE_NAME_LENGTH		OS_NAME_LENGTH
#define B_PATH_NAME_LENGTH 		PATH_MAX
#define B_ATTR_NAME_LENGTH		(OS_NAME_LENGTH - 1)
#define B_MIME_TYPE_LENGTH		MIME_TYPE_LEN
#define B_MAX_SYMLINKS			SYMLINK_MAX

#define B_READ_ONLY 			O_RDONLY
#define B_WRITE_ONLY 			O_WRONLY
#define B_READ_WRITE 			O_RDWR

#define	B_FAIL_IF_EXISTS		O_EXCL
#define B_CREATE_FILE			O_CREAT
#define B_ERASE_FILE			O_TRUNC
#define B_OPEN_AT_END			O_APPEND


/*
enum node_flavor {
  B_FILE_NODE=0x01,
  B_SYMLINK_NODE=0x02,
  B_DIRECTORY_NODE=0x04,
  B_ANY_NODE= 0x07
};
*/

#define MIME_TYPE_LEN			(OS_NAME_LENGTH - 15)

#endif
