/*  libcosmoe.so - the interface to the Cosmoe UI
 *  Copyright (C) 2001-2002 Bill Hayden
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2 as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA
 */


#ifndef __VOLUMEROSTER_H__
#define __VOLUMEROSTER_H__

#include <storage/Volume.h>
#include <app/Application.h>
#include <mntent.h>
#include <support/List.h>
#include <string>

#define BVolumeRoster	os::CVolumeRoster


namespace os {

class CVolume;
//class CMessenger;

class CVolumeRoster {

public:
					CVolumeRoster();
	virtual			~CVolumeRoster();

	status_t		GetNextVolume(CVolume *ioVolume);
	void			Rewind();

	status_t		GetBootVolume(CVolume *ioVolume);

// Methods to watch for mount/unmount events (unimplemented)

	//status_t		StartWatching(Messenger inMessenger);
	void			StopWatching(void) {};
	//CMessenger	Messenger(void) const;

private:

	void			_DeallocateMountList();

	virtual	void	FBC_VolumeRoster1();
	virtual	void	FBC_VolumeRoster2();

	CMessenger*		mTarget;
	int32			mCurrentPosition;
	CList			mMountList;

	uint32			FBC_Reserved[3];
};

}

#endif
