/*  libcosmoe.so - the interface to the Cosmoe UI
 *  Copyright (C) 2002 Bill Hayden
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2 as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA
 */


#ifndef	_AUTOLOCK_H
#define	_AUTOLOCK_H

#include <support/Locker.h>
#include <app/Looper.h>


#define BAutolock	os::CAutolock


namespace os
{

class CAutolock
{
public:
				CAutolock(CLocker *lock);
				CAutolock(CLocker &lock);
				~CAutolock()	{ if (mIsLocked && mLock) mLock->Unlock(); }
	
	bool		IsLocked()		{ return mIsLocked; }

private:
	CLocker*	mLock;
	bool		mIsLocked;
};


inline CAutolock::CAutolock(CLocker *target)
{
    mLock = target;
    mLock->Lock();
    mIsLocked = mLock->IsLocked();
}

inline CAutolock::CAutolock(CLocker &target)
{
    mLock = &target;
    mLock->Lock();
    mIsLocked = mLock->IsLocked();
}

}

#endif /* _AUTOLOCK_H */
