/*  libcosmoe.so - the interface to the Cosmoe UI
 *  Copyright (C) 2001-2002 Bill Hayden
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2 as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA
 */


#ifndef __STOPWATCH_H__
#define __STOPWATCH_H__

#include <support/SupportDefs.h>

#define BStopWatch 	os::CStopWatch

namespace os
{

class CStopWatch
{
public:
					CStopWatch(const char *name, bool silent = false);
	virtual			~CStopWatch();

	void			Suspend();
	void			Resume();
	bigtime_t		Lap();
	void			Reset();
	bigtime_t		ElapsedTime() const;
	const char*		Name() const { return mName; }

private:

	virtual void	FBC_StopWatch1();
	virtual void	FBC_StopWatch2();

	bigtime_t		mStartTime;
	bigtime_t		mSuspendTime;
	bigtime_t		mLaps[10];
	int32			mLap;
	char*			mName;
	bool			mSilent;
	uint32			FBC_Reserved[2];
};

}


#endif /* __STOPWATCH_H__ */
