/*  libcosmoe.so - the interface to the Cosmoe UI
 *  Portions Copyright (C) 2001-2002 Bill Hayden
 *  Portions Copyright (C) 1999-2001 Kurt Skauen
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2 as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA
 */


#ifndef __COSMOE_TYPES_H__
#define __COSMOE_TYPES_H__

typedef          signed   char  int8;       /* signed 8-bit quantity */
typedef          signed   short int16;      /* signed 16-bit quantity */
typedef          signed   int   int32;      /* signed 32-bit quantity */

typedef volatile signed   int   vint;
typedef volatile signed   char  vint8;
typedef volatile signed   short vint16;
typedef volatile signed   int   vint32;

typedef          unsigned char  uchar;
/* typedef          unsigned short ushort; */
/* typedef          unsigned int   uint; */
typedef          unsigned char  uint8;
typedef          unsigned short uint16;
typedef          unsigned int   uint32;

typedef volatile unsigned int   vuint;
typedef volatile unsigned char  vuint8;
typedef volatile unsigned short vuint16;
typedef volatile unsigned int   vuint32;

typedef            signed long long int64;
typedef          unsigned long long uint64;
typedef volatile          long long vint64;
typedef volatile unsigned long long vuint64;

typedef long long bigtime_t;
typedef int       status_t;

typedef int     port_id;
typedef int     thread_id;      /* Process ID           */
typedef int     proc_id;        /* Process ID           */
typedef int     area_id;
typedef int     team_id;
typedef int     sem_id;
typedef int     timer_id;
typedef int     image_id;
typedef int     fs_id;
typedef uint32	type_code;

#define	OS_NAME_LENGTH	64

#define INFINITE_TIMEOUT        (9223372036854775807LL)

#ifndef TRUE
#define TRUE        1
#endif
#ifndef FALSE
#define FALSE       0
#endif

#define min_c(a,b) ((a)>(b)?(b):(a))
#define max_c(a,b) ((a)>(b)?(a):(b))

#ifndef __cplusplus
typedef char bool;
enum {false,true};
#endif

#ifndef NULL
#define NULL 0L 
#endif

/* XXX: from <errno.h>, but nonstandard */
#define EOK			0
#define B_OK		EOK
#define B_NO_ERROR	EOK
#define B_ERROR		-1

/* FIXME */
#define O_NOTRAVERSE 0
//#define O_NOTRAVERSE O_NOFOLLOW

#endif
