/*  libcosmoe.so - the interface to the Cosmoe UI
 *  Portions Copyright (C) 2001-2002 Bill Hayden
 *  Portions Copyright (C) 1999-2001 Kurt Skauen
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2 as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA
 */


#ifndef __TYPECONSTANTS_H__
#define __TYPECONSTANTS_H__

#define	B_ANY_TYPE	os::T_ANY_TYPE
#define	B_BOOL_TYPE os::T_BOOL
#define	B_DOUBLE_TYPE 	os::T_DOUBLE
#define B_FLOAT_TYPE 	os::T_FLOAT
#define	B_INT64_TYPE 	os::T_INT64
#define	B_INT32_TYPE 	os::T_INT32
#define	B_INT16_TYPE 	os::T_INT16
#define	B_INT8_TYPE		os::T_INT8
#define	B_MESSAGE_TYPE	os::T_MESSAGE
#define B_MESSENGER_TYPE os::T_MESSENGER
#define	B_POINTER_TYPE 	os::T_POINTER
#define	B_POINT_TYPE 	os::T_POINT
#define	B_RAW_TYPE 		os::T_RAW
#define	B_RECT_TYPE 	os::T_RECT
#define B_REF_TYPE 		os::T_REF

// Currently unused/unsupported Be types:
//	B_MIME_TYPE					= 'MIME',
//	B_MONOCHROME_1_BIT_TYPE 	= 'MNOB',
//	B_OBJECT_TYPE 				= 'OPTR',
//	B_OFF_T_TYPE 				= 'OFFT',
//	B_PATTERN_TYPE 				= 'PATN',
//	B_CHAR_TYPE 				= 'CHAR',
//	B_COLOR_8_BIT_TYPE 			= 'CLRB',
//	B_GRAYSCALE_8_BIT_TYPE		= 'GRYB',
//	B_RGB_32_BIT_TYPE 			= 'RGBB',
//	B_RGB_COLOR_TYPE 			= 'RGBC',
//	B_SIZE_T_TYPE	 			= 'SIZT',
//	B_SSIZE_T_TYPE	 			= 'SSZT',
//	B_STRING_TYPE 				= 'CSTR',
//	B_TIME_TYPE 				= 'TIME',
//	B_UINT64_TYPE				= 'ULLG',
//	B_UINT32_TYPE				= 'ULNG',
//	B_UINT16_TYPE 				= 'USHT',
//	B_UINT8_TYPE 				= 'UBYT',
//	B_MEDIA_PARAMETER_TYPE		= 'BMCT',
//	B_MEDIA_PARAMETER_WEB_TYPE	= 'BMCW',
//	B_MEDIA_PARAMETER_GROUP_TYPE= 'BMCG',
//	B_ATOM_TYPE					= 'ATOM',
//	B_ATOMREF_TYPE				= 'ATMR',


namespace os
{

enum TypeCode
{
    T_ANY_TYPE,
    T_POINTER,
    T_INT8,
    T_INT16,
    T_INT32,
    T_INT64,
    T_BOOL,
    T_FLOAT,
    T_DOUBLE,
    T_STRING,
    T_IRECT,
    T_IPOINT,
    T_MESSAGE,
	T_MESSENGER,
    T_COLOR32,
    T_FILE,		// obsolete
    T_MEM_OBJ,	// obsolete
    T_RECT,
    T_POINT,
    T_VARIANT,
    T_RAW,
	T_REF
};

} // end of namespace


#endif // __TYPECONSTANTS_H__
