#include <app/Cursor.h>

using namespace os;

Cursor::Cursor(const void* cursorData)
{
	if (cursorData != NULL)
	{
		int numPixels = (char*)cursorData)[0];
		int dataBits;

		numPixels *= numPixels;		 	/* height * width = total pixels */

										/* pixels * depth + mask pixels  */
		dataBits = (numPixels * ((char*)cursorData)[1]) + numPixels;

		dataBits += (dataBits % 8);		/* round up to next byte		 */

		mDataSize = (dataBits / 8) + 4;
		mCursorData = malloc(mDataSize);
		memcpy(mCursorData, cursorData, mDataSize);
	}
}


Cursor::~Cursor()
{
	if (mCursorData != NULL)
		free(mCursorData);
}