/*  libcosmoe.so - the interface to the Cosmoe UI
 *  Copyright (C) 2001-2002 Bill Hayden
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2 as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA
 */


#include <app/Roster.h>
#include <app/Application.h>
#include <support/List.h>
#include <appserver/protocol.h>


using namespace os;

CRoster::CRoster()
{
}


CRoster::~CRoster()
{
}


bool	CRoster::IsRunning(const char *mime_sig) const
{
	return( TeamFor(mime_sig) != (team_id)0 );
}


bool	CRoster::IsRunning(EntryRef *ref) const
{
	return( TeamFor(ref) != (team_id)0 );
}


team_id	CRoster::TeamFor(const char *mime_sig) const
{
	CMessage  cReq( DR_GET_APP_TEAM );
	CMessage  cReply;
	team_id   theTeam;
	
	cReq.AddString( "app_mime_sig", mime_sig );
	
	CMessenger( CApplication::c_app->GetServerPort() ).SendMessage( &cReq, &cReply );

	cReply.FindInt32( "team_id", (int32*)&theTeam );
		
	return theTeam;
}


team_id	CRoster::TeamFor(EntryRef *ref) const
{
	return (team_id)0;
}


void	CRoster::GetAppList(CList *team_id_list) const
{
	GetAppList(NULL, team_id_list);
}


void	CRoster::GetAppList(const char *sig, CList *team_id_list) const
{
	CMessage cReq( DR_GET_APP_LIST );
	CMessage cReply;
	CList*   aList = NULL;
	
	if (sig != NULL)
		cReq.AddString( "app_mime_sig", sig );

	CMessenger( CApplication::c_app->GetServerPort() ).SendMessage( &cReq, &cReply );
	
	if (!cReply.IsEmpty())
	{
		team_id	aTeam;
		int32	i = 0;
		
		aList = new CList();
		
		while(true)
		{
			status_t err = cReply.FindInt32( "team_id", (int32*)&aTeam, i++ );
			
			if (err == EOK)
			{
				aList->AddItem((void*)aTeam);
				continue;
			}
			
			break;
		}
	}
	
	team_id_list = aList;
}


status_t	CRoster::GetAppInfo(const char *sig, app_info *info) const
{
	return -1;
}


status_t	CRoster::GetAppInfo(EntryRef *ref, app_info *info) const
{
	return -1;
}


status_t	CRoster::GetRunningAppInfo(team_id team, app_info *info) const
{
	return -1;
}


status_t	CRoster::GetActiveAppInfo(app_info *info) const
{
	return -1;
}


status_t	CRoster::FindApp(const char *mime_type, EntryRef *app) const
{
	return -1;
}


status_t	CRoster::FindApp(EntryRef *ref, EntryRef *app) const
{
	return -1;
}


status_t	CRoster::Broadcast(CMessage *msg) const
{
	return -1;
}


status_t	CRoster::Broadcast(CMessage *msg, CMessenger reply_to) const
{
	return -1;
}


status_t	CRoster::StartWatching(CMessenger target, uint32 event_mask) const
{
	return -1;
}


status_t	CRoster::StopWatching(CMessenger target) const
{
	return -1;
}


status_t	CRoster::ActivateApp(team_id team) const
{
	return -1;
}


status_t	CRoster::Launch(const char *mime_type, CMessage *initial_msgs,
				team_id *app_team) const
{
	return -1;
}


status_t	CRoster::Launch(const char *mime_type, CList *message_list,
				team_id *app_team) const
{
	return -1;
}


status_t	CRoster::Launch(const char *mime_type, int argc, char **args,
				team_id *app_team) const
{
	return -1;
}



status_t	CRoster::Launch(const EntryRef *ref, const CMessage *initial_message,
				team_id *app_team) const
{
	return -1;
}


status_t	CRoster::Launch(const EntryRef *ref, const CList *message_list,
				team_id *app_team) const
{
	return -1;
}


status_t	CRoster::Launch(const EntryRef *ref, int argc, const char * const *args,
				team_id *app_team) const
{
	return -1;
}


void		CRoster::GetRecentDocuments(CMessage *refList, int32 maxCount,
				const char *ofType,
				const char *openedByAppSig) const
{
}


void		CRoster::GetRecentDocuments(CMessage *refList, int32 maxCount,
				const char *ofTypeList[], int32 ofTypeListCount,
				const char *openedByAppSig) const
{
}


void		CRoster::GetRecentFolders(CMessage *refList, int32 maxCount,
				const char *openedByAppSig) const
{
}


void		CRoster::GetRecentApps(CMessage *refList, int32 maxCount) const
{
}


void		CRoster::AddToRecentDocuments(const EntryRef *doc,
				const char *appSig) const
{
}


void		CRoster::AddToRecentFolders(const EntryRef *folder,
				const char *appSig) const
{
}


