/*  libcosmoe.so - the interface to the Cosmoe UI
 *  Portions Copyright (C) 2001-2002 Bill Hayden
 *  Portions Copyright (C) 1999-2001 Kurt Skauen
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2 as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA
 */


#include <storage/VolumeRoster.h>

using namespace os;

CVolumeRoster::CVolumeRoster()
{
	struct mntent*	aMountEntry;
	FILE*			fstab;

	fstab = setmntent (_PATH_MOUNTED, "r");

	while ((aMountEntry = getmntent(fstab)))
	{
		mMountList.AddItem(new CVolume(aMountEntry));
	}

	if (endmntent(fstab) == 0)
	{
		int saved_errno = errno;

		_DeallocateMountList();

		errno = saved_errno;
	}

	mCurrentPosition = 0L;
}


CVolumeRoster::~CVolumeRoster()
{
	_DeallocateMountList();
}


status_t	CVolumeRoster::GetNextVolume(CVolume *ioVolume)
{
	CVolume*	aMount;

	aMount = (CVolume*)(mMountList.ItemAt(mCurrentPosition++));

	if (aMount != NULL)
	{
		*ioVolume = *aMount;
		return 0;
	}

	return -1;
}


void		CVolumeRoster::Rewind()
{
	mCurrentPosition = 0L;
}


status_t	CVolumeRoster::GetBootVolume(CVolume *inVolume)
{
	return -1;
}


void	CVolumeRoster::_DeallocateMountList()
{
	CVolume *aMount;

	while ((aMount = (CVolume*)(mMountList.RemoveItem(1L))) != NULL)
	{
		delete aMount;
	}
}


void		CVolumeRoster::FBC_VolumeRoster1() {};
void		CVolumeRoster::FBC_VolumeRoster2() {};


